d("MyWalletModel",['ccrz', 'log'], function(CCRZ,log) {  
    CCRZ.models.customMyWalletModel = CCRZ.CloudCrazeModel.extend({
        className : "CHAVCB2B_myAccountController",
        fetch : function(reqData,callback){
            this.invokeCtx('getAddressList', 
                reqData,  
                function(resp, evt){ 
                    if(callback){
                        callback(resp,evt);
                    }            
                }, 
                { 
                    buffer:false, 
                    nmsp : false 
                } 
                
            ); //end invokeCtx call
        },
        getWalletStoredPayments : function(req,callback){
            this.invokeCtx(
                'getWalletStoredPayments',req,
                function(response,evt){
                    if(response && response.success){
                        callback(response,evt);
                    }
                },
                { 
                    buffer:false, //this call will be executed by itself 
                    nmsp : false //defines that this is a call to a subscriber class 
                }
            )
        }
    });
    return CCRZ.models.customMyWalletModel;
});
