d("StoredPaymentsPOView",['ccrz', 'util', 'StoredPaymentsPOModel'], function(CCRZ, UTIL, StoredPaymentsPOModel){
    return {
        extendStoredPaymentsPOView: function() {
            
            CCRZ.views.StoredPaymentsPOView = CCRZ.CloudCrazeView.extend({
                viewName : "StoredPaymentsPOView",
                /* Template ID referenced here*/ 
                paymentType : '',
                templateDesktop: CCRZ.util.template(CCRZ.uiProperties.StoredPaymentsPOView.desktop.tmpl),
                templatePhone: CCRZ.util.template(CCRZ.uiProperties.StoredPaymentsPOView.desktop.tmpl),
                contactMailing : {},
                
                init : function(options){
                    this.selector = options.selector;
                    this.render();
                    CCRZ.pubSub.trigger('action:paymentViewInit', this);        
                    let url=CCRZ.pagevars.currSiteURL;
                    let userLocale=CCRZ.pagevars.userLocale;
                    let _this = this;
                    this.paymentType='Cybersource';
                    /*if(countryCode == 'CA'){
                        this.paymentType='Paysafe'
                    }
                    else if(countryCode == 'US'){
                        this.paymentType='Cybersource'
                        
                    }*/
                    this.selector = options.selector;
                    /* remoting cloudcarze remoting callout _this.model */
                    _this.invokePGInitiation(this.paymentType);
                    
                    CCRZ.geoCodes = new CCRZ.models.GeoModel();
                        CCRZ.geoCodes.fetch(function() {
                        _this.model.set({
                            countryList: CCRZ.geoCodes.countryList.toJSON()
                        });
                        _this.model.getContactmailingAddress(function(response, event){
                            if(response.success){
                                if(response.data){
                                    this.contactMailing = response.data;
                                    if(this.contactMailing != undefined){
                                        if(this.contactMailing.MailingCountry !== undefined){
                                            populateCountry();
                                            populateState(this.contactMailing.MailingCountry);
                                        }
                                        document.getElementById('cardFirstName').value = this.contactMailing.FirstName !== undefined ? this.contactMailing.FirstName : "";
                                        document.getElementById('cardLastName').value = this.contactMailing.LastName !== undefined ? this.contactMailing.LastName : ""; 
                                        document.getElementById('cardStreet').value =this.contactMailing.MailingStreet !== undefined ? this.contactMailing.MailingStreet : "";
                                        document.getElementById('cardCity').value = this.contactMailing.MailingCity !== undefined ? this.contactMailing.MailingCity : ""; 
                                        document.getElementById('countryId').value = this.contactMailing.MailingCountry !== undefined ? this.contactMailing.MailingCountry : "";
                                        document.getElementById('cardPostalCode').value = this.contactMailing.MailingPostalCode !== undefined ? this.contactMailing.MailingPostalCode : "";
                                        document.getElementById('stateId').value = this.contactMailing.MailingState !== undefined ? this.contactMailing.MailingState : "";                    
                                    }
                                }
                            }
                        });
                    });
                    
                },
                postRender : function(){
                    //renderMicroFlexForm();
                        let _this= this;
                        _this.model.set('isInit', true);
                    let respData= this.model.get('data');
                    populateCountry();
                    if(this.paymentType == 'Cybersource'){
                        //renderMicroFlexForm(respData);
                    }
                    changeCountry();
                    UTIL.hideLoader();
                   /* else if(this.paymentType=='Paysafe'){
                        //paysafe();
                        B2BpaysafeForm(respData);
                }*/
                },
                events: {
                    'change #cardType' : 'handleCartTypeChange'
                },
                renderDesktop : function(){
                    $(CCRZ.uiProperties.StoredPaymentsPOView.phone.selector).empty();
                    this.setElement($(CCRZ.uiProperties.StoredPaymentsPOView.desktop.selector));
                    this.$el.html(this.templateDesktop({}));
                },
                renderPhone : function(){
                    $(CCRZ.uiProperties.StoredPaymentsPOView.desktop.selector).empty();
                    this.setElement($(CCRZ.uiProperties.StoredPaymentsPOView.phone.selector));
                    this.$el.html(this.templatePhone({}));
                },
                handleCartTypeChange: function(){
                    // Validate Card
                    let respData= this.model.get('data'), _this = this;
                    let init = _this.model.get('isInit');
                    if(init && this.paymentType == 'Cybersource'){
                        _this.model.set('isInit', false);
                        populateCountry();
                        renderMicroFlexForm(respData, _this);
                        $("#makePODPayment").prop("disabled", false);
                    } else {
                        if(!init){
                            $('input[name="credit-card-number"]').value = '';
                        }
                    }
                },
                invokePGInitiation: function(paymentType){
                    
                    let _this = this;
                    let cartId = CCRZ.pagevars.currentCartID;
                    let reqData;
                    let mid;
                    reqData={paymentType: paymentType,
                            url:CCRZ.pagevars.currSiteURL,
                            cartEnyId:CCRZ.pagevars.currentCartID};
                    _this.model.fetchPublicKey(JSON.stringify(reqData),function(response, event){
                        
                        if(response == null){
                            console.log('issue with form');                           
                            document.body.scrollTop = 0; // For Safari
                            document.documentElement.scrollTop = 0; 
                            $("#errordiv").css("display", "block");
                            $("#errorMsg").html(CCRZ.pagevars.pageLabels.CybersourceFormError);
                            $("#makePODPayment").prop("disabled", true);
                        }
                        else{
                            if(response.success) {
                                _this.model.set('data',response.data);
                                
                                if(_this.paymentType == 'Cybersource'){
                                    //renderMicroFlexForm(response.data);
                                }
                            } else {
                                alert(response.data);
                            }
                        }
    
                    });                
                }
            });

            CCRZ.paymentViews = CCRZ.paymentViews || {};
                
            CCRZ.paymentViews.po = new CCRZ.views.StoredPaymentsPOView({
                model : new CCRZ.models.StoredPaymentsPOModel(),
            });          
            function populateCountry(){
                
                let countryList =  CCRZ.geoCodes.countryList.toJSON();
                countryList = countryList.filter(function(country){
                    return country.value == 'US';
                });
                let coutryData = ''; 
                $.each(countryList,function(index,data){
                    coutryData +='<option value="'+data.value+'">'+data.label+'</option>';
                });
                $('#countryId').html(coutryData);
                window.setTimeout(function(){
                    $('#countryId').val('US');
                    populateState('US');
                }, 500);
            }
            function populateState(countryCode){
                let stateList = CCRZ.geoCodes.filterStates(countryCode).toJSON();
                    let stateHtml = '';
                    $.each(stateList,function(index,data){
                        stateHtml+='<option value="'+data.value+'">'+data.label+'</option>';
                    });
                $('#stateId').html(stateHtml);
            }
            function changeCountry(){
                $('#countryId').on('change', function() {
                    populateState(this.value);
                });
            }
            function renderMicroFlexForm(resData){
                var isValidate=false;
                var cardError = '';
                var cardType = '';
                if(resData!= null){
                    var jwk = JSON.parse(resData).jwk;
                    var cyberSourceform = document.getElementById('cyberSource-form');
                    var flexResponse = document.querySelector('#flex-response');
                    var expMonth = document.querySelector('#expMonth');
                    var expYear = document.querySelector('#expYear');
                    var cvv=document.querySelector('#cvv'); 
                    populateCountry();
                    //populateState('US');
                    if(this.contactMailing != undefined){
                        if(this.contactMailing.MailingCountry !== undefined){
                            populateState(this.contactMailing.MailingCountry);
                        }
                        document.getElementById('cardFirstName').value = this.contactMailing.FirstName !== undefined ? this.contactMailing.FirstName : "";
                        document.getElementById('cardLastName').value = this.contactMailing.LastName !== undefined ? this.contactMailing.LastName : ""; 
                        document.getElementById('cardStreet').value =this.contactMailing.MailingStreet !== undefined ? this.contactMailing.MailingStreet : "";
                        document.getElementById('cardCity').value = this.contactMailing.MailingCity !== undefined ? this.contactMailing.MailingCity : ""; 
                        document.getElementById('countryId').value = this.contactMailing.MailingCountry !== undefined ? this.contactMailing.MailingCountry : "";
                        document.getElementById('cardPostalCode').value = this.contactMailing.MailingPostalCode !== undefined ? this.contactMailing.MailingPostalCode : "";
                        document.getElementById('stateId').value = this.contactMailing.MailingState !== undefined ? this.contactMailing.MailingState : "";                    
                    }
                    
                    // SETUP MICROFORM
                    FLEX.microform(
                        {
                            keyId: jwk.kid,
                            keystore:jwk,
                            container: '#cardNumber-container',
                            label: '#cardNumber-label',
                            placeholder: 'Enter Card Number here',
                            styles: {
                                'input': {
                                    'font-family': '-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol"',
                                    'font-size': '1rem',
                                    'line-height': '1.5',
                                    'color': '#495057',
                                },
                                ':focus': {'color': '#a94442'},
                                ':disabled': {'cursor': 'not-allowed'},
                                'valid': {'color': '#3c763d'},
                                'invalid': {'color': '#a94442'},
                            },
                            encryptionType: window.Label.B2BCust_encryptionType
                        },
                        function (setupError, microformInstance) {
                            console.log('setupError '+setupError);
                            if (setupError) {
                                // handle error
                                return;
                            }
                            var isCardValid = false;
                            microformInstance.on('validationChange',function(data){
                                if(data.valid){
                                    isCardValid = true;
                                }
                                else{
                                    isCardValid = false;
                                }
                            });  
                            microformInstance.on('cardTypeChange', function(data) {
                                if(data.card != undefined){
                                    cardType = data.card[0].brandedName;
                                }
                            });
                            // intercept the form submission and make a tokenize request instead
                            cyberSourceform.addEventListener('submit', function () {
                                event.preventDefault();
                                isValidate= validateFields();
                                if(!isValidate){
                                    
                                    $("#makePODPayment").prop("disabled", true);
                                    setTimeout(function () {
                                        $("#makePODPayment").prop("disabled", false);
                                    }, 6000);
                                    return;
                                }
                                var cardcheck = validateCard(cardType);
                                if (!cardcheck){
                                    $("#makePODPayment").prop("disabled", true);
                                    setTimeout(function () {
                                        $("#makePODPayment").prop("disabled", false);
                                    }, 6000);
                                    return;
                                }
                                if(!isCardValid){
                                    document.body.scrollTop = 0; // For Safari
                                    document.documentElement.scrollTop = 0; 
                                    $("#errordiv").css("display", "block");
                                    if(cardError){
                                        $("#errorMsg").html(cardError);
                                    }
                                    else{
                                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_All_validCardError').toString());
                                    }                                    
                                    $("#makePODPayment").prop("disabled", true);
                                    setTimeout(function () {
                                        $("#errordiv").css("display", "none");
                                        $("#makePODPayment").prop("disabled", false);
                                    }, 6000);
                                    return;
                                }                  
                                // Send in optional parameters from other parts of your payment form
                                var options = {
                                    cardExpirationMonth: expMonth.value,
                                    cardExpirationYear: expYear.value,
                                    code:cvv.value,
                                    // cardType:cardType.value
                                };
                                
                                microformInstance.createToken(options, function (err, response) {
                                    if (err) {
                                        if(isCardValid){
                                            var x='<div class="alert alert-danger alert-dismissible errorcydiv">';
                                            x=x+'<a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>';
                                            x=x+'<span id="errorcyMsg"></span></div>';
                                            $(x).insertBefore( "#overlayDivOne");
                                            $("#overlayDivOne").hide();
                                            $("#errorcyMsg").html(CCRZ.processPageLabelMap('KFB2B_All_validCvvError').toString());
                                            document.body.scrollTop = 0; // For Safari
                                            document.documentElement.scrollTop = 0; 
                                        
                                            $(".errorcydiv").show();
                                            setTimeout(function () {
                                                //$(".errorcydiv").css("display", "none");
                                                //$(".errorcydiv").hide();
                                                $(".errorcydiv").remove();
                                                $("#makePODPayment").attr("disabled", false);
                                                $("#makePODPayment").removeAttr("disabled");
                                                $(".processBack").prop('disabled', false);
                                                $(".processBack").removeAttr('disabled');
                                            }, 6000);
                                        }       
                                        return;
                                    }
                                    
                                    console.log('Token generated: ');
                                    // At this point the token may be added to the form
                                    // as hidden fields and the submission continued
                                    flexResponse.value = JSON.stringify(response);
                                    
                                    if(flexResponse.value !==null){
                                        $(".alert-danger").addClass("hidden");
                                        event.preventDefault();
                                        response['expMonth']=document.querySelector('#expMonth').value;
                                        response['expYear']= document.querySelector('#expYear').value;
                                        response['storefrontName']= CCRZ.pagevars.storefrontName;
                                        response['userId']=CCRZ.currentUser.Id;
                                        response['accId']=CCRZ.currentUser.Contact.AccountId;
                                        response['firstName']=document.getElementById("cardFirstName").value;
                                        response['lastName']=document.getElementById("cardLastName").value;
                                        response['ccStreet']=document.getElementById('cardStreet').value,
                                        response['ccCity']=document.getElementById('cardCity').value,
                                        response['ccState']=document.getElementById('stateId').value,
                                        response['ccPostalCode']=document.getElementById('cardPostalCode').value,
                                        response['ccCountry']=document.getElementById('countryId').value,
                                        storedPayment(JSON.stringify(response));
                                    }
                                });
                            });
                        }
                    );  
                }
            }

            function remvError(ele1){
                $('.'+ele1).css('border-color','#3c763d');}
    
            function isNumberKey(evt) {
                var charCode = (evt.which) ? evt.which : event.keyCode;
                if (charCode > 31 && (charCode < 48 || charCode > 57)){
                    return false;
                }
                return true;
            }
        
            function validateFields(){
                
                $("#makePODPayment").attr("disabled", true);
                $("#overlayDivOne").css("display", "block");
                var firstName=document.getElementById("cardFirstName").value;
                var lastName=document.getElementById("cardLastName").value;
                var payType=document.getElementById("cardType").value;
                var cardNumb=document.getElementById("cardNumber-container").value;
                var expY=document.getElementById("expYear").value;
                var expM=document.getElementById("expMonth").value;
                var cvv=document.getElementById("cvv").value;          
                var cardStreet = document.getElementById("cardStreet").value;
                var cardCity = document.getElementById("cardCity").value;
                var cardPostalCode = document.getElementById("cardPostalCode").value;
                
                if(firstName == ""
                      || lastName == "" 
                        ||  expM == ""
                            || expY == ""
                                || cvv == ""
                                    || payType == ""
                                        || cardStreet == "" 
                                            || cardCity == "" 
                                                || cardPostalCode == ""){                  
                    var textVal = validateNameFields(firstName,lastName);
                    if(textVal == 'success') {                        
                        if($(".creditMsg").hasClass("hidden")){
                           $('.creditMsg').addClass('hidden');
                        }                        
                    }
                    else{
                        return;
                    }
                    if(payType == ""){
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_All_validCardType').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }
                    if($("#expMonth").val().length < 2 ||expM > 12 || expM < 1){                        
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_expMonthError').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }
                    if($("#expYear").val().length < 4 || new Date().getFullYear() > $("#expYear").val()){
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_expYearError').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }                    
                    if(payType == '003'){
                        if($("#cvv").val().length !== 4){                            
                            document.body.scrollTop = 0; // For Safari
                            document.documentElement.scrollTop = 0; 
                            $("#errordiv").css("display", "block");
                            $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_cvvAmexError').toString());
                            $("#makePODPayment").prop("disabled", true);
                            setTimeout(
                                function(){
                                    $("#errordiv").css("display", "none");
                                    $("#makePODPayment").prop("disabled", false);
                                }, 
                                6000
                            );
                            return ;
                        }
                    }
                    else if($("#cvv").val().length !== 3){                            
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_cvvError').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }       
                    
                    if(cardStreet == ""){
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_streetError').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }
                    if(cardCity == ""){
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_cityError').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }
                    if(cardPostalCode == ""){
                        document.body.scrollTop = 0; // For Safari
                        document.documentElement.scrollTop = 0; 
                        $("#errordiv").css("display", "block");
                        $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_postalCodeError').toString());
                        $("#makePODPayment").prop("disabled", true);
                        setTimeout(
                            function(){
                                $("#errordiv").css("display", "none");
                                $("#makePODPayment").prop("disabled", false);
                            }, 
                            6000
                        );
                        return ;
                    }
                    
                    isValidate =false;                                                             
                }   
                else{
                    isValidate = true;
                }
                return isValidate;    
            }
            validateNameFields = function(first,last) {
                
                //var firstName = document.getElementById("cardFirstName").value; //$("cardFirstName").val();
                //var lastName = document.getElementById("cardLastName").value; //$("cardLastName").val();
                var firstName = first;
                var lastName = last;
                var textMsg ='';
                if(firstName == '' || !firstName.match(/^[a-zA-Z\s]+$/)){
                    document.body.scrollTop = 0; // For Safari
                    document.documentElement.scrollTop = 0;
                    $("#errordiv").css("display", "block");
                    $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_firstNameError').toString());
                    $("#makePODPayment").prop("disabled", true);
                    setTimeout(function () {
                        $("#errordiv").css("display", "none");
                        $("#makePODPayment").prop("disabled", false);
                    }, 6000);
                    return;               
                }
                else if( lastName == '' || !lastName.match(/^[a-zA-Z\s]+$/)){
                    document.body.scrollTop = 0; // For Safari
                    document.documentElement.scrollTop = 0;
                    $("#errordiv").css("display", "block");
                    $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_myAccount_lastNameError').toString());
                    $("#makePODPayment").prop("disabled", true);
                    setTimeout(function () {
                        $("#errordiv").css("display", "none");
                        $("#makePODPayment").prop("disabled", false);
                    }, 6000);
                    return;                     
               }
               else {
                   textMsg ='success';
                   return textMsg;
               }
       
               //return textMsg;
            }
            function validateCard(type){
                
                var cardError;               
                var cardType=document.getElementById("cardType").value;
                var cardName;
                if(cardType == '001'){
                    cardName = CCRZ.processPageLabelMap('KFB2B_Visa').toString();
                }
                else if(cardType == '002'){
                    cardName = CCRZ.processPageLabelMap('KFB2B_MasterCard').toString();
                }
                else if(cardType == '003'){
                    cardName = CCRZ.processPageLabelMap('KFB2B_American_Express').toString();
                }
                else if(cardType == '004'){
                    cardName = CCRZ.processPageLabelMap('KFB2B_Discover').toString();
                }
                else {
                    $("#errordiv").css("display", "block");                    
                    $("#errorMsg").html(CCRZ.processPageLabelMap('KFB2B_All_validCardType').toString());                                            
                    $("#makePODPayment").prop("disabled", true);
                    setTimeout(function () {
                        $("#errordiv").css("display", "none");
                        $("#makePODPayment").prop("disabled", false);
                    }, 6000);
                    return false;
                }                             
                if(cardName.toLowerCase() !== type.toLowerCase()){                               
                    cardError = CCRZ.processPageLabelMap('KFB2B_All_enterValidCard').toString() + cardName;
                    document.body.scrollTop = 0; // For Safari
                    document.documentElement.scrollTop = 0; 
                    $("#errordiv").css("display", "block");                    
                    $("#errorMsg").html(cardError);                                            
                    $("#makePODPayment").prop("disabled", true);
                    setTimeout(function () {
                        $("#errordiv").css("display", "none");
                        $("#makePODPayment").prop("disabled", false);
                    }, 6000);
                    return false;
                } 
                return true;                                  
            }

            function storedPayment(resp){
                var remoteCall = _.extend(CCRZ.RemoteInvocation,{className:'KFB2B_MyWallet_CreditCardCX'});
                remoteCall.invokeCtx(
                    'storePaymentDetails',resp,
                    function(res, event)
                    {
                        if(event.status){
                            console.table('res.data: '+res.data);
                            if(res['success']===true){
                                console.log(res.data);
                                try{
                                        $('.creditMsg').addClass('hidden');
                                    $.alert({
                                        title:window.Label.B2BCust_ThanksYou,
                                        content: CCRZ.processPageLabelMap('KFB2B_All_futureTransactions').toString()                                               
                                    });
                                    /* redirecting the page*/
                                    myWallet();
                                } 
                                catch(e){
                                } 
                            }
                            else {
                                var x='<div class="alert alert-danger alert-dismissible" id="errordiv">';
                                x=x+'<a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>';
                                x=x+'<span id="errorMsg"></span></div>';
                                $(x).insertBefore( "#overlayDivOne");
                                $("#overlayDivOne").hide();
                                $("#errorMsg").html('{!$Label.B2BCust_Cyber_PaymentError }');
                                document.body.scrollTop = 0; // For Safari
                                document.documentElement.scrollTop = 0; 
                                $("#errordiv").show();
                                $(".makePODPayment").removeAttr("disabled");
                                setTimeout(function () {
                                    $("#errordiv").css("display", "none");
                                    $("#makePODPayment").prop("disabled", false);
                                }, 6000);
                                return; 
                            }
                        }
                    },{buffer:false,escape:false,nmsp:false}
                );        
            }
        }
    }
});