d("myAccountInvoiceView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendAccountInvoiceView: function() {
            CCRZ.customInvoiceList = [];
            CCRZ.isCustomInvoices = false;
            CCRZ.pubSub.once("view:myInvoicesView:refresh", function(invoiceView) {
                UTIL.showLoader();
                invoiceView.renderPhone = function(){
                    if(this.dataReady && CCRZ.customInvoiceList.length > 0) {
                     this.$el.html('');
                     this.$el.html(this.templatePhone({
                      'invoiceList': CCRZ.customInvoiceModel.toJSON()//(CCRZ.customInvoiceList.length > 0)?CCRZ.customInvoiceList.toJSON():[]
                      ,'canPay' : false
                     }));
                    }
                }
                invoiceView.renderDesktop = function(){
                     this.$el.html('');
                     if(!_.isUndefined(CCRZ.customInvoiceModel)) {
                        this.$el.html(this.templateDesktop({
                            'invoiceList'    : CCRZ.customInvoiceModel.toJSON()//(CCRZ.customInvoiceList.length > 0)?CCRZ.customInvoiceList.toJSON():[]
                           ,'searchFormData' : this.searchFormData
                           ,'canPay' : false
                          }));
                          UTIL.hideLoader();
                     }
                };
                invoiceView.preRender = function() {
                    if(!this.dataLoadStarted && !CCRZ.isCustomInvoices) {
                        this.dataModel.fetch();
                        this.dataLoadStarted=true;
                    } else if(CCRZ.isCustomInvoices && !this.dataReady){
                        fetchInvoices(this);
                    }
                };
                invoiceView.render();
            });
            CCRZ.pubSub.once("view:navigatePaginationView:refresh", function(invoiceView) {
                if(CCRZ.myaccountView.subView.viewName == 'myInvoicesView'){
                    fetchInvoices(CCRZ.myaccountView.subView);
                }
            });

            //Fetch New invoices
            function fetchInvoices(_this){
                CCRZ.remoteModel.getInvoices(JSON.stringify({}),function(res, evt){
                    let invoiceList = [], invoiceCollection = [];
                    if(res && res.success && res.data && res.data.invoiceList && res.data.invoiceList.length > 0){
                        CCRZ.customInvoiceList = res.data.invoiceList;
                        res.data.invoiceList.forEach(function(invoice, index){
                            let invoiceObj = new CCRZ.models.InvoiceSummaryModel(invoice);
                            if(index < 10){
                                invoiceList.push(invoiceObj);
                            }
                            invoiceCollection.push(invoiceObj);
                        });
                        let totalPages = invoiceCollection.length%10;
                        CCRZ.invoicesPaginatorView.model.fullCollection.length = res.data.invoiceList.length;
                        CCRZ.invoicesPaginatorView.model.fullCollection.models = invoiceCollection;
                        CCRZ.invoicesPaginatorView.model.length = 10;
                        CCRZ.invoicesPaginatorView.model.models = invoiceList;
                        CCRZ.invoicesPaginatorView.model.state.totalRecords = res.data.invoiceList.length;
                        CCRZ.invoicesPaginatorView.model.state.totalPages = totalPages;
                        CCRZ.invoicesPaginatorView.model.state.lastPage = totalPages;
                        CCRZ.invoicesPaginatorView.model.state.hasNext = (totalPages <= 1)?false:true;
                        CCRZ.invoicesPaginatorView.model.state.endPage = totalPages;
                    } else {
                        CCRZ.invoicesPaginatorView.model.fullCollection.length = 0;
                        CCRZ.invoicesPaginatorView.model.fullCollection.models = [];
                        CCRZ.invoicesPaginatorView.model.length = 0;
                        CCRZ.invoicesPaginatorView.model.models = [];
                        CCRZ.invoicesPaginatorView.model.state.totalRecords = 0;
                        CCRZ.invoicesPaginatorView.model.state.totalPages = 1;
                        CCRZ.invoicesPaginatorView.model.state.lastPage = 1;
                        CCRZ.invoicesPaginatorView.model.state.hasNext = false;
                        CCRZ.invoicesPaginatorView.model.state.endPage = 1;
                    }
                    CCRZ.customInvoiceModel = CCRZ.invoicesPaginatorView.model;
                    CCRZ.isCustomInvoices = true;
                    _this.dataReady = true;
                    CCRZ.myaccountView.subView.render();
                });
            }
        }
    }
});