d("myAccountYourDownloads",['ccrz', 'util', 'customSubscriptionView'], function(CCRZ, UTIL, customSubscriptionView) {
    return {
        extendMyAccountYourDownloads: function() {
            let subscView = customSubscriptionView.extendcustomSubscriptionView();
            if(CCRZ.MyAccount){
                CCRZ.MyAccount = _.extend(CCRZ.MyAccount||{},{
                    yourDownloads :{
                        register : function(registrar){
                            registrar.registerNewView('yourDownloads', CCRZ.processPageLabelMap('KFB2B_All_MyDownloads_Text').toString(), subscView);
                        }
                    }
                });
            }
            CCRZ.pubSub.once('view:myaccountView:awaitingSubViewInit', function(theView){
                if(CCRZ.MyAccount.contactInfo){
                CCRZ.MyAccount.contactInfo.register(theView);
                }

                if(CCRZ.MyAccount.yourDownloads){
                    CCRZ.MyAccount.yourDownloads.register(theView);
                }
            
                if(CCRZ.MyAccount.changePassword){ 
                CCRZ.MyAccount.changePassword.register(theView);
                }
            
                /*if(CCRZ.MyAccount.myCarts){
                CCRZ.MyAccount.myCarts.register(theView);
                }*/
                if(CCRZ.pagevars.pageConfig.get('shop_restrict.res_orders') != 'TRUE'){
                    if(CCRZ.MyAccount.myOrders){
                        CCRZ.MyAccount.myOrders.register(theView);
                    }
                }
            
                /*if(CCRZ.MyAccount.myWishlists){
                CCRZ.MyAccount.myWishlists.register(theView);
                }*/

                if(CCRZ.MyAccount.myWallet){
                CCRZ.MyAccount.myWallet.register(theView);
                }
                if(!CCRZ.pagevars.isNonAccredited){
                    if(CCRZ.pagevars.pageConfig.get('shop_restrict.res_invoice') != 'TRUE'){
                        if(CCRZ.MyAccount.myInvoices){
                            CCRZ.MyAccount.myInvoices.register(theView);
                        }
                    }
                }
                let viewState = (CCRZ.pagevars.queryParams.viewState?CCRZ.pagevars.queryParams.viewState:'viewAccount');
                theView.currIndex = theView.sectionMap[viewState]||0;
                theView.subView = theView.subViewArray[theView.currIndex].view;
                CCRZ.myaccountView.render();
            });

        }
    }
});