d("myAccountWalletView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendAccountWalletView: function() {
            CCRZ.pubSub.once("view:myWalletView:refresh", function(walletView) {
                walletView.events['click .paymentDelete'] = 'openDeleteModal';
                walletView.events['click .deletePayment'] = 'deletePayment';
                walletView.openDeleteModal = function(event) {
                    var objLink = $(event.currentTarget);
                    var pid = objLink.data("pid");
                    var modalData = {"pid": pid};
                    var modalView = new CCRZ.views.deleteModal();
                    modalView.render(modalData, function() {
                        $('#deleteMod_' + modalData.pid).modal({ keyboard: false, backdrop: 'static', show: true });
                        $('#deleteMod_' + modalData.pid).removeClass('fade');
                        $('#deleteMod_' + modalData.pid + ' .modal-dialog').addClass('modal-lg');
                        $('.modal-backdrop').removeClass('fade');
                    });
                };
                walletView.deletePayment = function(event) {
                    UTIL.showLoader();
                    var me = this;
                    var objLink = $(event.currentTarget);
                    var pid = objLink.data("pid");
                    $("#deleteMod_" + pid).modal("hide");
                    this.dataModel.deletePayment(pid, function(){
                        me.render();
                    });
                };
                walletView.renderDesktop = function(){
                    this.$el.html(this.templateDesktop(this.data));
                    UTIL.hideLoader();
                };
                walletView.renderPhone = function(){
                    this.$el.html(this.templatePhone(this.data));
                    UTIL.hideLoader();
                };
                walletView.delegateEvents();
                walletView.render();
            });
        }
    }
});