d("myAccountWLView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendAccountWLView: function() {
            let isRefresh = false;
            CCRZ.pubSub.on("view:myWishlistsView:refresh", function(wishView) {
                if(!isRefresh){
                    wishView.editEntity = function(event) {
                        let id = event.currentTarget.dataset.id, selList = this.wishlistData.get(id);
                        this.openModal(selList);
                    };
                    wishView.openModal = function(wishlistBean) {
                        let modalView = new CCRZ.views.wishlistEditModal();
                        modalView.render(wishlistBean, function() {
                         $('#renameMod_' + wishlistBean.attributes.sfid).modal("show");
                         $('#renameMod_' + wishlistBean.attributes.sfid).removeClass('fade');
                         $('.modal-backdrop').removeClass('fade');
                        });
                    };
                    wishView.saveEntity = function(event) {
                        UTIL.showLoader();
                        let objLink = $(event.target);
                        var id = objLink.data("id");
                        var v = this;
                        var formData = form2js('renameForm', '.', false, function(node) {}, false, true);
                        this.closeModal(id);
                        this.wishlistData.editEntity(id, formData,function(id){
                         v.wishlistData.fetch(function() { v.render();});
                        });
                    };
                    wishView.deleteEntity = function(event) {
                        UTIL.showLoader();
                        let id = event.currentTarget.dataset.id, v = this;
                        this.wishlistData.deleteEntity(id, function() { v.render();});
                    };
                    wishView.renderDesktop = function(){
                        if(this.dataReady) {
                         let v = this;
                         v.$el.html(v.templateDesktop(v.wishlistData.toJSON()));
                         UTIL.hideLoader();
                        }
                    };
                    wishView.delegateEvents();
                    isRefresh = true;
                    wishView.render();
                }
            });
        }
    }
});